<template>
    <div>
        <material-button @click="onClick" :styles="['mdc-button--outlined']">
            Import
        </material-button>
        <material-dialog
            v-if="dictionary"
            id="upload-dialog"
            @closing="hideDialog()"
            :show="show"
            :header="`Import csv to ${dictionary.name} dictionary`"
        >
            <template v-slot:actions>
                <material-button :styles="['mdc-dialog__button', 'mdc-button--outlined']">
                    <span>Select file</span>
                    <input
                        @change="onChange($event)"
                        type="file"
                        accept="text/csv"
                        class="upload-button__input"
                    />
                </material-button>
                <material-button
                    @click="onImportAction"
                    :styles="['mdc-dialog__button', 'mdc-button--outlined']"
                    data-mdc-dialog-action="import"
                    :disabled="fileContents.length === 0"
                >Import</material-button>
            </template>

            <material-textfield
                v-model="fileContents"
                placeholder="Type your csv..."
                rows="5"
                cols="150"
            />
        </material-dialog>
    </div>
</template>
<script>
export default {
    props: {
        dictionaries: {
            type: Array,
            required: true,
        },
        dictionary: {
            type: Object,
        },
    },

    data() {
        return {
            show: false,
            fileContents: '',
        };
    },
    methods: {
        hideDialog() {
            this.show = false;
        },
        resetFileContents() {
            this.fileContents = '';
        },
        onClick() {
            this.show = true;
        },
        onImportAction() {
            this.importCsv(this.fileContents);
        },
        onChange(event) {
            if (event.target.files.length) {
                const file = event.target.files[0];

                if (file.type !== 'text/csv') {
                    this.$toasted.error('Incorrect file type.');
                }

                this.readFile(file);
            }
        },
        readFile(file) {
            const reader = new FileReader();
            reader.readAsText(file, 'UTF-8');
            reader.onload = event => {
                this.fileContents = event.target.result;
            };
        },
        importCsv(contents) {
            axios.post(`dictionaries/${this.dictionary.id}/phrases`, {
                phrases: contents.split(',').map(phrase => {
                        return {
                            phrase: phrase,
                        };
                    }),
                })
                .then(() => {
                    this.resetFileContents();

                    this.$toasted.show('Phrases imported');

                    this.$emit('phrases-imported');
                })
                .catch(error => {
                    this.$toasted.global.apiError(error);
                });
        },
    },
};
</script>
<style>
.upload-button__input {
    opacity: 0;
    position: absolute;
    top: 0;
    right: 0;
    width: 100%;
    height: 100%;
    cursor: pointer;
}
</style>
